function dist = Dist(img_train, img_test)

SIZEY = size(img_train,1);
SIZEX = size(img_train,2);

[idy, idx] = find(img_test == 0);
pointsnum_test = size(idy,1);
%calculate the center
p = [idx, idy]; % x and y coordinates
center_test = round(mean(p));
%compute the voting vector dv for each point 
cmat = repmat(center_test, pointsnum_test, 1);
dv = cmat - p;

[idy, idx] = find(img_train == 0);
pointsnum_train = size(idy,1);
q = [idx, idy]; 

vote_space = zeros(SIZEY,SIZEX);
for n = 1 : pointsnum_train %for each black pixel in train image
    pmat = repmat(q(n,:), pointsnum_test, 1);
    %vote for the center
    vote_points = pmat + dv;
    id = find(vote_points(:,1) >= 1 & vote_points(:,1) <= SIZEX &...
              vote_points(:,2) >= 1 & vote_points(:,2) <= SIZEY);
    if ~isempty(id)      
      pid = vote_points(id,2) + (vote_points(id,1) - 1) * SIZEY;
      vote_space(pid) = vote_space(pid) + 1;
    end 
end   

dist = (max(pointsnum_train,pointsnum_test) + sqrt(pointsnum_train*pointsnum_test))/max(vote_space(:)); 

end