function  KNN_Query(K)
% For given Query images, find their KNN
% And output the result to a txt file

num_people = 4;
num_image = 143;
I = cell(num_people*num_image);
names = cell(num_people*num_image);
DownsampleSize = 30;

%% Read in traces in the database
for num_dir = 1:num_people
    D = uigetdir('','Choose one directory from Trace_ini');
    flist=dir(D);
    fnum = length(flist);
    i = 1;
    j = 0;
    while i <= fnum
        if ~flist(i).isdir && ~strcmp(flist(i).name,'Thumbs.db')
            j = j + 1;
            name = flist(i).name;
            img = imread(sprintf('%s/%s',D,name));
            image_bw = im2bw(img,graythresh(img));
            num = (num_dir-1)*num_image + j;
            I{num} = normalize_img(image_bw,DownsampleSize);
            names{num} = strcat(num2str(num_dir),'_',name);
        end
        i = i + 1;
    end
end

%% Read in Queries
D = uigetdir('','Choose an image directory with Queries');
flist=dir(D);
fnum = length(flist);
i = 1;
j = 0;
while i <= fnum
    if ~flist(i).isdir && ~strcmp(flist(i).name,'Thumbs.db')
        j = j + 1;
        name = flist(i).name;
        img = imread(sprintf('%s/%s',D,name));
        image_bw = im2bw(img,graythresh(img));
        Q{j} = normalize_img(image_bw,DownsampleSize);
        names_Q{j} = name;
    end
    i = i + 1;
end
qnum = j;


%% KNN
fid = fopen(strcat(D,'/KNN.txt'),'a');
for q = 1:qnum
    fprintf(fid,'%s\r\n',names_Q{q});
    KNN = zeros(K,1);
    dist_KNN = 999*ones(K,1);

    for i = 1:num_people*num_image
        dist = Dist(I{i},Q{q});
        if dist < dist_KNN(K)
            %replace the last one
            dist_KNN(K) = dist;
            KNN(K) = i;
            %reorder dist_KNN and KNN
            [dist_KNN ind] = sort(dist_KNN);
            KNN = KNN(ind);
        end
    end

    KNN_name = cell(K);
    for i = 1:K
        KNN_name{i} = names{KNN(i)};
        fprintf(fid,'%s\r\n',KNN_name{i});
    end
    fprintf(fid,'\r\n');

end
fclose(fid);



